

#include "assert.h"
#include "reader.h"
#include "tokenizer.h"
#include "parsestack.h"


int main( int argc, char* argv [] )
{

   tokenizer tt;

   parsestack p( tkn_Start, 0 ); 
      // Start in state 0 for token tkn_Start.

   while( ! p. accepts( tt ))
   {
      std::cout << p << "\n";
      if( tt. lookahead. size( ) == 0 )
         tt. scan( );

      if( p. size( ) == 0 )
      {
         std::cout << "unexpected end of file\n"; 
         return 0; 
      }

      const position& top = p. top( );
      std::cout << "lookahead symbol = " << tt. lookahead. front( ) << "\n\n";

      // You can use nested switches, nested ifs, or use tables,
      // whatever you think gives the nices solution.

      switch( top. type )
      {
      default:
         tt. lookahead. pop_front( );
            // In the incomplete version, we just throw away the
            // lookahead, so that the program will reach end of file
            // at least. `
      }
   }

   // Actually if the size of lookahead gets 0, something went wrong.

   ASSERT( tt. lookahead. size( ));
   std::cout << tt. lookahead. front( ) << "\n";
      // This is an EOF token. 
   return 0;
 
}


